## Script (Python) "addtoMailFolder_unpack_part"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=theMail,file,partno
##title=Add man to Mail Folder (unpack_part)
##

self = context

import mimetools
import StringIO

headers = mimetools.Message(file)
type = headers.getmaintype()
if type == 'multipart':
    boundary = headers.getparam("boundary")
    file.push(boundary)
    file.readlines()
    while not file.last:
        file.next()
        partno = partno + 1
        self.addtoMailFolder_unpack_part(theMail, file, partno)
    file.pop()
    return

name = headers.getparam("name")
subtype = headers.getsubtype()
if type=='text' and subtype=='plain' and not name:
    # overwrite the body so that we get _only_ the body text.
    # (Uses the plain version of the body in all situations.
    #  HTML formated body will be in the attachments dictionary)
    if theMail['body'] != '':
        theMail['body'] = theMail['body'] + '\n--body--\n'
    theMail['body'] = theMail['body'] + file.read()
else:
    if not name:
        name = 'part%d' % (partno,)
        name = name + '-'+subtype

    encoding = headers.getencoding()

    outfile = StringIO.StringIO()
    if encoding == '7bit':
        mimetools.copyliteral(file,outfile)
    else:
        mimetools.decode(file,outfile,encoding)

    theMail['attachments'][name]=outfile.getvalue()
    outfile.close()
